#include <stdio.h>
#include <dos.h>
#include <string.h> /* and maybe io.h fcntl.h */

/* ************************************************************ */

#define DOPM 1
/* ^- really activate protected mode */
/* #define HANG 1 */
/* ^- hang in generic int handler */
#define DLY 100000
/* ^- waiting while in PM is better than doing nothing at all in PM */
#define TRYINT 1
/* ^- define to trigger an INT 80h while in PM */

/* ************************************************************ */

typedef unsigned long int dword;
typedef unsigned int word;
typedef unsigned char byte;
typedef struct { word iplo,cs,type,iphi; } IDTDESC_T;
typedef struct { dword a,b; } GDTDESC_T;
typedef struct { word limit; dword flatpos; } DTWHERE_T;

/* ************************************************************ */

/* externals: */
int is386(int needpm);
int goprot(GDTDESC_T near *gdt, IDTDESC_T near *idt, word irqpos);
unsigned int ramsize(dword near * under16m, dword near * above16m);
int copyflat(dword src, dword dst, dword size);
int setpmstuff(DTWHERE_T near * gdtp, DTWHERE_T near * idtp,
    word ldt, dword cr3, word tss, word oldtss);
int getxms(dword size, dword near * pos, dword near * remaining);
int mkidt(void far * chandler, IDTDESC_T far * idtpos, word handlerds);
int fallbacktoreal(int killflat);
/* externals done */

/* ************************************************************ */

typedef struct { word handlerip, handlercs;
  dword edi, esi, ebp, esppm, ebx, edx, ecx, eax;
  word espm, dspm, fspm, gspm, errorcode, intnum;
  dword eip, cs, eflags, espother, ssother, es86, ds86, fs86, gs86;
  } HREGS_T;

IDTDESC_T myidt[256];
GDTDESC_T mygdt[16];
char strbuf[160+32]; /* char, attr, char, attr, ... */
dword strbufpos;
dword csflatpos;
HREGS_T hregstest[1];

/* ************************************************************ */

#ifndef DOPM
#define Xcopyflat rmcopyflat
void rmcopyflat(dword src, dword dst, dword cnt)
{
 (void)movedata(src>>4, src & 15, dst>>4, dst & 15, cnt);
}
#endif

#ifdef DOPM
#define Xcopyflat copyflat       /* use only in PM+RM, not V86! */
#endif
/* copyflat uses BIOS in real mode, 4GB DS in any prot mode,    */
/* so it will fail in V86, which is also some prot mode!        */

/* ************************************************************ */

int byhex(byte val, int pos)
{
  byte dig;
  dig = val >> 4;
  dig = (dig >= 10) ? ((dig-10)+'a') : (dig+'0');
  strbuf[pos] = dig; pos+=2;
  dig = val & 15;
  dig = (dig >= 10) ? ((dig-10)+'a') : (dig+'0');
  strbuf[pos] = dig; pos+=2;
  strbuf[pos] = ' '; pos+=2;
  return pos;
}

int wordhex(word val, int pos)
{
  signed char cnt;
  char dig;
  for (cnt=12; cnt>=0; cnt-=4) {
    dig = val >> cnt;
    dig &= 15;
    dig = (dig >= 10) ? ((dig-10)+'a') : (dig+'0');
    strbuf[pos] = dig; pos+=2;
  }
  return pos;
}

int dwordhex(dword val, int pos)
{
  int pos2;
  pos2 = wordhex(val>>16, pos);
  return wordhex(val & 0xffff, pos2);
}

int strpoke(char near * str, int pos)
{
  while ((str[0] != 0) && (pos<160)) {
    strbuf[pos] = str[0]; str++; pos+=2;
  }
  return pos;
}

int dumpmem(dword where, int pos)
{
  int pos2 = pos;
  int cnt = 160;
  int cnt2 = 0;

  if (where>=8) {
    pos2 = strpoke("pre: ",pos);
    where -= 8; cnt2 = 8;
  }
  if ((where+cnt2+16) > 0x200000) {
   pos2 = strpoke(" <insane addr: above 2mb>",pos2);
   return pos2;
  }
  Xcopyflat(strbufpos+cnt, where, cnt2 + 16); /* special buffer! */
  if (cnt2>0) {
    for (cnt=160;cnt<(160+cnt2);cnt2++) {
      pos2 = byhex(strbuf[cnt], pos2);
    }
  }
  pos2 = strpoke(" post: ",pos2);
  for (cnt2=0;cnt2<16;cnt2++) {
    pos2 = byhex(strbuf[cnt+cnt2], pos2);
  }
  return cnt2;
}

/* ************************************************************ */

void myhandler(HREGS_T far * hregs)
{
  int cpos = 0;
  int cline = 0;
  for (cpos=1;cpos<160;cpos+=2) { strbuf[cpos]=0x1e; };
  cpos = strpoke("Handler @ ",0);
  cpos = wordhex(hregs->handlercs,cpos); cpos = strpoke(":",cpos);
  cpos = wordhex(hregs->handlerip,cpos); cpos = strpoke(" Int/Code: ",cpos);
  cpos = wordhex(hregs->intnum,cpos); cpos = strpoke("/",cpos);
  cpos = wordhex(hregs->errorcode,cpos); cpos = strpoke(" Eflags: ",cpos);
  cpos = dwordhex(hregs->eflags,cpos);
  Xcopyflat(strbufpos, 0x0b8000+cline, cpos); cline+=160;
  cpos = strpoke("CS:EIP @ ",0); cpos = wordhex(hregs->cs,cpos);
  cpos = strpoke(":",cpos); cpos = dwordhex(hregs->eip,cpos);
  cpos = strpoke(" eax=",cpos); cpos = dwordhex(hregs->eax,cpos);
  cpos = strpoke(" ebx=",cpos); cpos = dwordhex(hregs->ebx,cpos);
  cpos = strpoke(" ecx=",cpos); cpos = dwordhex(hregs->ecx,cpos);
  cpos = strpoke(" edx=",cpos); cpos = dwordhex(hregs->edx,cpos);
  Xcopyflat(strbufpos, 0xb8000+cline, cpos); cline+=160;
  cpos = strpoke("Flags: ",0); cpos = dwordhex(hregs->eflags,cpos);
  cpos = strpoke(" esi=",cpos); cpos = dwordhex(hregs->eax,cpos);
  cpos = strpoke(" edi=",cpos); cpos = dwordhex(hregs->ebx,cpos);
  cpos = strpoke(" ebp=",cpos); cpos = dwordhex(hregs->ecx,cpos);
  cpos = strpoke(" esp=",cpos); cpos = dwordhex(hregs->edx,cpos);
  Xcopyflat(strbufpos, 0xb8000+cline, cpos); cline+=160;
  cpos = strpoke("Caller SS:ESP @ ",0);
  cpos = wordhex(hregs->ssother,cpos); cpos = strpoke(":",cpos);
  cpos = dwordhex(hregs->espother,cpos); cpos = strpoke(" PM DS=",cpos);
  cpos = wordhex(hregs->dspm,cpos); cpos = strpoke(" ES=",cpos);
  cpos = wordhex(hregs->espm,cpos); cpos = strpoke(" FS=",cpos);
  cpos = wordhex(hregs->fspm,cpos); cpos = strpoke(" GS=",cpos);
  cpos = wordhex(hregs->gspm,cpos);
  Xcopyflat(strbufpos, 0xb8000+cline, cpos); cline+=160;
  /* we could also translate the PM segs - from GDT or LDT */
  if (hregs->eflags & 0x20000) { /* bit 17, VM flag */
    cpos = strpoke(" Caller is V86 task: DS=",0);
    cpos = wordhex(hregs->ds86,cpos);
    cpos = strpoke(" ES=",cpos); cpos = wordhex(hregs->es86,cpos);
    cpos = strpoke(" FS=",cpos); cpos = wordhex(hregs->fs86,cpos);
    cpos = strpoke(" GS=",cpos); cpos = wordhex(hregs->gs86,cpos);
  } else {
    cpos = strpoke("no V86 status available",0);
  };
  Xcopyflat(strbufpos, 0xb8000+cline, cpos); cline+=160;

  if ( ((hregs->cs & 3 /* DPL */) != (_CS & 3 /* CPL */))
    && (!(hregs->eflags & 0x20000)) ) {
    cpos = strpoke("PM other stack: ", 0);
    cpos = strpoke("??? - GDT/LDT readout not implemented",cpos);
    /* cpos = dumpmem(...); */
    Xcopyflat(strbufpos, 0xb8000+cline, cpos); cline+=160;
    cpos = strpoke("PM other code: ", 0);
    cpos = strpoke("??? - GDT/LDT readout not implemented",cpos);
    /* cpos = dumpmem(...); */
    Xcopyflat(strbufpos, 0xb8000+cline, cpos); cline+=160;
  }
  if (hregs->cs == _CS) {
    cpos = strpoke("in our PM code: ",0);
    cpos = dumpmem(csflatpos + hregs->eip, cpos);
    Xcopyflat(strbufpos, 0xb8000+cline, cpos); cline+=160;
  }
  if (hregs->eflags & 0x20000) {
    cpos = strpoke("V86 stack: ",0);
    cpos = dumpmem( (((dword)hregs->ssother)<<4) +
      hregs->espother, cpos);
    Xcopyflat(strbufpos, 0xb8000+cline, cpos); cline+=160;
    cpos = strpoke("V86 code:  ",0);
    cpos = dumpmem( (((dword)hregs->cs)<<4) +
      hregs->eip, cpos);
    Xcopyflat(strbufpos, 0xb8000+cline, cpos); cline+=160;
  }
#ifdef HANG
  strbuf[0] = 32; strbuf[2] = 32;
  while (1) {
    strbuf[2] = (strbuf[2]>127) ? 32 : (strbuf[2]+1);
    if (strbuf[2]==32) {
      strbuf[0] = (strbuf[0]>127) ? 32 : (strbuf[0]+1);
    }
    Xcopyflat(strbufpos, 0xb8000+800,4);
  };
#endif
}

/* ************************************************************ */

void main(void)
{
  word w;
  dword sz;
  dword pos;
  dword rem;
  dword below16m;
  dword above16m;

  printf("is386(0): %d is386(1): %d\n", is386(0), is386(1));
  w = ramsize(&below16m,&above16m);
  printf("ramsize() returns: %dk, below16m: %ld, above16m: %ld\n",
    w, below16m, above16m);

  strbufpos = _DS;
  strbufpos <<= 4;
  strbufpos += (word)&strbuf[0];
  csflatpos = _CS;
  csflatpos <<= 4;

  w = _DS;
  _DS = _CS;	/* for mkidt (selfmodifying code) */
  (void)mkidt( MK_FP(_CS, &myhandler),
    MK_FP(_DS, &myidt[0]), _DS);
  _DS = w;

  sz = 123456;
  w = getxms(sz, &pos, &rem);
  printf("alloc %ld bytes XMS: pos %lxh, rem %ldk, hand %d\n",
      sz, pos, rem, w);
  sz = w;
  sz = -sz;
  w = getxms(sz, &pos, &rem);
  printf("free hand %ld XMS: pos %lxh, rem %ldk, hand %d\n",
      -sz, pos, rem, w);

#ifdef DOPM
  (void)mkidt( MK_FP(0x30, &myhandler), MK_FP(_DS, &myidt[0]), 0x18);
  /* recreate IDT contents *and* update handler to use CS 0x30, DS 0x18 */
  for (w=0; w<256; w++) {
    /* word iplo,cs,type,iphi; (type is 8e00h: P,PL 0, int gate) */
    myidt[w].cs = 0x30;	/* fill in the changed CS ! */
    /* update CS slots in IDT, too (mkIDT used own CS here...)! */
  }
  w = goprot(&mygdt[0], &myidt[0], 0); /* 0: do not remap IRQ */
#endif

  if (w!=0xffff){
    myhandler((HREGS_T far *)MK_FP(_DS, &hregstest));
    for (sz=0; sz<DLY; sz++) {
      strbuf[0] = (byte)sz; Xcopyflat(strbufpos, 0xb8000+2, 2);
    }
#ifdef TRYINT
    __emit__(0x0cd,0x80);	/* just a "spurious int 80h" to test sth. */
    for (sz=0; sz<DLY; sz++) {
      strbuf[0] = (byte)sz; Xcopyflat(strbufpos, 0xb8000+2, 2);
    }
#endif
    w = fallbacktoreal(1);
    /* ^- else the Turbo C stub and DOS will blast us away, obvious */
    /* (stub->int21.25->restore the int vecs... then int21.4c exit) */
    for (sz=0; sz<DLY; sz++) {
      strbuf[0] = (byte)sz; Xcopyflat(strbufpos, 0xb8000+4, 2);
    }

  } else {

    printf("Switch to protected mode has failed\n");

  }

}
